package com.github.roschlau.adventofcode.core.solvers.y2018

import com.github.roschlau.adventofcode.core.args
import kotlinx.coroutines.runBlocking
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.MethodSource

class Day13Test {

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part1Args")
    fun `part 1`(input: String, solution: String) = runBlocking {
        assertEquals(solution, Day13().solvePart1(input))
    }

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part2Args")
    fun `part 2`(input: String, solution: String) = runBlocking {
        assertEquals(solution, Day13().solvePart2(input))
    }

    @Suppress("unused")
    companion object {
        @JvmStatic
        fun part1Args() = args(
            inputTest1 to "7,3"
            ,input to "108,60"
        )
        @JvmStatic
        fun part2Args() = args(
            inputTest2 to "6,4"
            ,input to "92,42"
        )
    }
}

private val inputTest1 = """
/->-\
|   |  /----\
| /-+--+-\  |
| | |  | v  |
\-+-/  \-+--/
  \------/
""".trimIndent()

private val inputTest2 = """
/>-<\
|   |
| /<+-\
| | | v
\>+</ |
  |   ^
  \<->/
""".trimIndent()

private val input = """
           /----------------------------------------------------------------\                                     /-----------------\
           |                                                                |                              /------+-----------------+-----------\
    /------+---------------\                /-------------------------------+------------------------------+------+---------------\ |           |
    |      |               |                v                 /-------------+-------------\                |      |               | |           |
    |      |               |                |   /-------------+-------------+-------------+----------------+------+---------------+-+---------\ |
    |      |               |           /----+---+---\         |             |             |     /----------+------+-----------\   | |         | |
    |      |               |           |    |   |   |         |            /+-------------+-----+----------+-----\|           |   | |         | |
   /+------+---------------+-----------+----+---+---+---------+------------++-------------+-----+----------+-\   ||           |   | |         | |
   ||      |               |       /---+----+---+---+---------+------------++-------------+-----+-------\  | |   ||           |   | |         | |
   ||      |               | /-----+---+----+-\ |   |         |         /--++-------------+-----+-------+--+-+---++----\      |   | |         | |
   ||      |               | |     |   |    | | |   |        /+---------+--++-------------+-----+-------+--+-+---++----+------+---+-+----\    | |
/--++------+---------------+-+-----+---+----+-+-+---+--------++---------+--++---\         |  /--+-------+--+-+---++----+------+\  | |    |    | |
|  ||      |               | |     |   |    | | |   |        ||         |  ||   |         |  |  |       |  | |   ||    |      ||  | |    |    | |
|  ||      |               | |     |   |  /-+-+-+---+----\  /++---------+--++---+-\      /+--+--+-------+--+-+---++----+------++--+-+----+----+-+-\
|  ||      | /-------------+-+-----+---+--+-+-+-+---+----+--+++---------+--++---+-+------++--+--+-\     |  ^ |   ||    |     /++--+-+----+\   | | |
|  ||      | |          /--+-+-----+---+--+-+-+-+---+----+--+++---------+--++---+-+------++--+-\| |     |  | |   ||/---+-----+++--+-+----++--\| | |
|  ||      | |          |  | | /---+---+--+-+-+\|   |    |  |||         |/-++---+-+------++--+-++-+-----+--+-+-\ |||   |     |||  | |    ||  || | |
|  ||      | |          |  | | |/--+---+--+-+-+++---+----+--+++---------++-++---+-+------++--+-++\|     |  | | | |||   |     |||  | |    ||  || | |
|  |\------+-+----------+--/ | ||  |   |  | | |||   |    |  |||         || ||   | |      ||  | ||||     |  | | | |||   |     |||  | |    ||  || | |
|  |       | |          |    | ||  |   | /+-+-+++---+----+--+++---------++-++---+-+------++--+-++++-----+--+-+-+-+++---+-----+++--+-+--\ ||  || | |
|  |       | |          |    \-++--+---+-++-+-/||   |    |  |||         || ||   | |      ||  | ||||     |  | | | |||   |     |||  | |  | ||  || | |
|  |       | |          |      ||  |   | || v  ||/--+----+--+++---------++-++---+-+------++--+-++++-----+--+-+-+-+++---+--\  |||  | |  | ||  || | |
|  |       | |          |      ||  |   \-++-+--+++--/    |  |||         || ||   | |      ||  | ||||     |  | | | |||   |  |  |||  | |  | ||  || | |
|  |   /---+-+----------+-----\||  |     || |  |||       |  |||         || ||   | |      ||  | ||||     |  | | | |\+---+--+--+++--+-/  | ||  || | |
|  |   |   | |          |     |||  |     || |  |||   /---+--+++---------++-++---+\|     /++--+-++++----\|  | | | | |   |  |  |||  |    | ||  || | |
|  |   |  /+-+----------+---\ |||  |     || |  |||   |   |  |||    /----++-++---+++---\ |\+--+-++++----++--+-+-+-+-+---+--+--+++--+----+-++--++-+-/
|  |   |  || |          |/--+-+++--+-----++-+--+++---+\  |  \++----+----++-++---++/   | | |  | ||||    ||  | | | | |   |  |  |||  |    | ||  || |
|  |   |  || |      /---++--+-+++--+-----++-+--+++---++--+-\ || /--+----++-++---++----+-+-+--+-++++---\||  | | | | |   |  |  |||  |    | ||  || |
|  |   |  || |     /+---++--+-+++--+-----++-+--+++---++--+-+-++-+--+----++-++---++----+-+-+--+-++++---+++--+-+-+\| |   |  |  |||  |    | ||  || |
|  |   |  || |     ||   ||  | |||  |     || |  |||   ||  | | || |  |/---++-++---++--\ | | |  | ||||   |||  | | ||| |   |  |  |||  |    | ||  || |
|  |   |  || |  /--++---++--+-+++--+-\   || |  |||  /++--+-+-++-+--++---++-++---++-\| | | |  | ||||   |||  | | ||| |   |  |  |||  |    | ||  || |
|  |   |  || |  |  ||   || /+-+++--+-+---++-+--+++--+++--+-+-++-+--++---++-++---++-++-+-+-+--+-++++---+++--+-+-+++-+-\ |  |  |||  |    | ||  || |
|  |   |  || |  |  ||   || || |||  | |   || |  |||  |||  | | || |  ||   || ||/--++-++-+-+-+--+-++++---+++--+-+-+++-+-+-+--+--+++--+----+-++--++\|
|  |   |  || |  |  ||   || || |||  | | /-++-+--+++--+++--+-+-++\|  ||   || |||  || || | | |  | ||||   |||  | | ||| | | |  |  |||  |    | ||  ||||
|  |   |/-++-+--+--++---++-++-+++--+-+\| || |  |||  ||| /+-+-++++-<++---++-+++-\|| || | | |  | ||||   |||  \-+-+++-+-+-+--+--+++--+----+-++--+++/
|  |   || || |  |  ||   || || |||  | ||| || |  |||  ||| || | ||||  ||   || ||| ||| || | | |  | ||||   |||    | ||| | | |  |  |||  |    | ||  |||
|/-+---++-++-+--+--++--\|| || |||  | ||| || |/-+++--+++-++-+-++++--++---++-+++-+++-++-+-+-+--+-++++---+++----+-+++-+\| |/-+--+++--+----+-++--+++----\
|| |   || || |  |  ||  ||| || |||  | ||| || || |||  ||| || | ||||  ||   || ||| ||| || | |/+--+-++++---+++----+-+++-+++-++\|  |||  |    | ||  |||    |
|| |   || || |  |  ||  ||| || |||  | ||v || || |||  ||| || | ||||  ||   || ||| ||| || | |||/-+-++++---+++--\ | ||| ||| ||||  |||  |    | ||  |||    |
|| |   || || |  |  ||  ||| ||/+++--+-+++-++-++-+++--+++-++-+-++++--++---++-+++-+++-++\| |||| | ||||   |||  | | |v| \++-++++--+++--+----+-++--/||    |
|| |   || || |  |  ||  ||| ||||||  | |||/++-++-+++--+++-++-+-++++--++---++-+++-+++-++++-++++-+-++++---+++--+-+\|||  || ||||  |||  |    | ||   ||    |
|| |   || || |  |  ||  ||| ||||||  | |||||| || |||  ||| || | ||||  ||   || ||| ||| |||| |||| | ||||   |||  | |||||  || ||||  |||  |    | ||   ||    |
|| |   || || |  |  ||  ||| ||||||  | |||||| || ||| /+++-++-+-++++--++---++-+++-+++-++++-++++-+-++++---+++--+-+++++--++-++++--+++--+----+-++---++\   |
|| |   || || |  |  ||  ||| |||||| /+-++++++-++-+++-++++-++-+-++++--++---++-+++-+++-++++-++++-+-++++---+++--+-+++++--++-++++-\|||  |    | ||   |||   |
|| |   || || |  |  ||  ||| |||||| || |||||| || ||| |||| || | |||\--++---++-+++-+++-++++-++++-+-++++---/||  |/+++++--++-++++-++++\ |    | ||   |||   |
|| |   || || |  |  ||  ||| |||||| || |||||| || ||| ||||/++-+-+++---++---++-+++-+++-++++-++++-+-++++\   || /+++++++--++\|||| ||||| |    | ||   |||   |
|| |   || || |  |  ||  ||| |||||| || |||||| || ||| ||||||| | |||   ||   || ||| ||| |||| |||| | |||||   || ||||||||  ||||||| ||||| |    | ||   |||   |
|| \---++-++-+--+--++--+++-++++++-++-++++++-++-+++-+++++++-+-+++---++---++-+++-+++-++++-++++-+-+++++---++-+++/||||  ||||||| ||||| |    | ||   |||   |
||     || || |  |  \+--+++-++++++-++-++++++-++-+++-+++++++-+-+++---++---++-+++-+++-++++-++++-+-+++++---++-+++-++/|  ||||||| ||||| |    | ||   |||   |
||     || || |  |   |  ||| |||||| || |||||| || ||| ||||||| | |||   ||   || ||| ||| |||| |||| | |||||   || ||| || |  ||||||| ||||| |    | ||   |||   |
|| /---++-++-+--+---+--+++-++++++-++-++++++-++-+++-+++++++-+-+++---++---++-+++-+++\|||| |||| | |||||   || ||| || |  ||||||| ||||| |    | ||   |||   |
|| |   || || |  |   | /+++-++++++-++-++++++-++-+++-+++++++-+-+++---++---++-+++-++++++++-++++-+-+++++\  || ||| || |  ||||||| ||||| |    | ||   |||   |
|| |   || || | /+---+-++++-++++++-++-++++++-++-+++-+++++++-+-+++---++\  || ||| |||||||| |||| | ||||||  || ||| || |  ||||||| ||||| |    | ||   |||   |
|| |   || || | ||   | |||| |||||| || |||||| || ||| ||\++++-+-+++---+++--++-+++-++/||||| |||| | ||||||  || ||| || |  ||||||| ||||| |    | ||   |||   |
|| |   || || | ||   | |||| |||||| || |||||| || ||| || |||| | |||   |||  || ||| || ||||| |||| | ||||||  || ||| || |  ||||||| ||||| |    | ||   |||   |
|| |   || || | ||   | |||| |||||| || |||||| || ||| |\-++++-+-+++---+++--++-+++-++-+/||| |||| | ||||||  || ||| || |  ||||||| ||||| |    | ||   |||   |
|| |   || || | ||   | |||| |||||| || ||||||/++-+++-+--++++-+-+++---+++--++-+++-++-+-+++-++++-+-++++++--++-+++-++-+--+++++++-+++++-+--\ | ||   |||   |
|| |   || || | ||   | |||| |||||| || ||||||||| ||| |  |||| | |||   |||  || \++-++-+-+++-++++-+-++++++--++-+++-++-/  ||||||| ||||| |  | | ||   |||   |
|| |   || || | ||   | |||| |||||| || ||||||||| |\+-+--++++-+-+++---+++--++--++-++-+-+++-++++-+-++++++--++-+++-++----+++++++-+++++-+--+-+-++---/||   |
|| |   || || | ||   | ||||/++++++-++-+++++++++-+-+\|  |||| | |||   |||  ||  || || | ||| \+++-+-++++++--/| |||/++<---+++++++-+++++-+--+-+-++----++---+\
|| |   || || | ||   | ||||||||||| || ||||||||| | |||  |||| | \++---+++--++--++-++-+-+++--+++-+-++++++---+-++++++----+++++++-+++++-+--+-+-/|    ||   ||
|| |   || |^ | ||   | ||||||||||| || |||||||||/+-+++--++++-+--++---+++\ ||  || || | |||  ||| | ||||||   | ||||||    ||||||| ||||| |  | |  |    ||   ||
|| |   || || | ||   | ||||||||||| || ||||||||||| |||  |||| | /++---++++-++--++-++-+-+++--+++-+-++++++---+-++++++--\ ||||||| ||||| |  | |  |    ||   ||
|| |   || || | ||   | ||||||||||| || ||||||||||| |||  |||| | |||   |||| ||  || || | |||  ||| | ||||||   | ||||||  | ||||||| ||||| |  | |  |    ||   ||
|| |/--++-++-+-++---+-+++++++++++-++-+++++++++++-+++--++++-+\|||   |||| ||  || || | |||  ||| | ||||||   | ||||||  | ||||||| ||||| |  | |  |    ||   ||
|| ||  || || | ||   | ||||||||||| || ||||||||\++-+++--++++-+++++---++++-++--++-++-+-+++--+++-+-++++++---+-++++++--+-/|||||| ||||| |  | |  |    ||   ||
|| ||  || || | ||   | |||\+++++++-++-++++++++-++-+++--/||| |||||/--++++-++--++-++-+-+++--+++-+-++++++---+-++++++\ |  |||||| ||||| |  | |  |    ||   ||
|| ||  ||/++-+-++---+-+++-+++++++-++-++++++++-++-+++---+++-++++++--++++-++--++-++-+-+++--+++-+-++++++---+-+++++++\|  |||||| ||||| |  | |  |    ||   ||
|| ||  ||||| | ||   | ||| ||||||| || |||||\++-++-+++---++/ ||||||  |^|| || /++-++-+-+++--+++-+-++++++---+-+++++++++--++++++-+++++-+--+-+--+----++-\ ||
||/++--+++++-+-++---+\||| ||||||| || ||||| || || |||   ||  ||||||  |||| |\-+++-++-+-+++--+++-+-++++++---+-+++++/|||  |||||| ||||| |  | |  |    || | ||
|||||  ||||| | ||   ||||| ||||||| || ||||| || || |||   ||  ||||||  |||| |  ||| || | |||  ||| | ||||||   | ||||| |||  |||||| ||||| |  | |  |    || | ||
|||||  ||||| | ||   ||||| ||||||| |\-+++++-++-++-+++---++--++++++--++++-+--+++-++-+-+++--+++-+-++++++---//+++++-+++--++++++-+++++-+--+-+--+\   || | ||
|||||  ||||| | ||   ||||| ||||||| |  ||\++-++-++-+++---++--++++/|  ||||/+--+++-++-+-+++--+++-+-++++++----++++++-+++--++++++-+++++-+--+-+\ ||   || | ||
|||||  ||||| | ||   ||||| ||||||| |  || || || || |||   ||  |||| |  ||||||  ||| || | |||  |||/+-++++++----++++++-+++--++++++-+++++-+--+\|| ||   || | ||
|||||  ||||| | ||   ||||| ||||||| |  || || || || |||   || /++++-+--++++++--+++-++-+-+++--+++++-++++++----++++++-+++--++++++-+++++-+--++++-++---++-+\||
|||||  ||||| | ||   ||||| ||||||| |  || || || || |||   || ||||| |  ||||||  ||| || | |||  ||||\-++++++----++++++-+++--++++++-+++/| |  |||| ||   || ||||
|||||  ||||| | \+---+++++-+++++++-+--++-++-++-++-+++---++-+++++-+--++/|||  ||| || | |||  ||||  ||||||    |||||| |||  |||||| ||| | |  |||| ||   || ||||
|||^|  ||||| |  |   ||||| ||||||| |  || || || || |||   || ||||| |  || |||  ||| || | |||  |||| /++++++----++++++-+++--++++++-+++-+-+--++++-++---++\||||
|||||  ||||| |  |   ||||| ||||||| |  || || || || |||   || |||\+-+--++-+++--+++-++-+-+++--++++-+++++++----++++++-++/  |||||| ||| | |  |||| ||   |||||||
|||||  ||||| |  |   ||||| |||||\+-+--++-++-++-+/ |||   || ||| \-+--++-+++--+++-++-+-+++--+/|| |||||||  /-++++++-++---++++++-+++-+-+--++++\||   |||||||
|||||  ||||| |  \---+++++-+++++-+-+--/| || || |  |||   || |||   |  || |||  ||| || | |||  | || ||\++++--+-++++++-++---++++++-++/ | |  |||||||   |||||||
|||||  ||||| |      |v||| ||||| | |   | || || |  |||   || |||   |  \+-+++--+++-++-+-++/  | || || ||||/-+-++++++-++---++++++-++--+-+-\|||||||   |||||||
|||||  ||||| |    /-+++++-+++++-+-+---+-++-++-+--+++---++-+++---+---+\|||  ||| || | ||   | || || ||||| | |||\++-++---++++++-++--/ | ||||||||   |||||||
|^|||  ||||| |    | ||||| ||||| | |   | || || |  |||   || |||   |   ||||\--+++-++-+-++---+-++-++-+++++-+-+++-++-++---++/||| ||    | ||||||||   |||||||
|||||  ||||| |    | ||||| ||||| |/+---+-++-++-+--+++---++-+++---+---++++---+++-++-+-++---+-++-++-+++++-+-+++-++-++---++-+++-++----+\||||||||   |||||||
|||||  ||||| |    | ||||| ||||| |||   | || || |  |||   || |||   |   ||||   ||| || | ||   | || || ||||| |/+++-++-++\  || ||| ||    ||||||||||   |||||||
|||||  ||||| |    | ||||| ||||| |||   | || || |  |||   |\-+++---+---++++---+++-/| | ||  /+-++-++-+++++-+++++-++-+++--++-+++\||    ||||||||||   |||||||
|||||  ||||| | /--+-+++++-+++++-+++---+-++-++-+--+++---+--+++---+--\||||   |||  | | ||  || || || ||||| ||||| || |||  || ||||||    ||||||||||   |||||||
|||||  ||||| | |  | ||||| ||||| ||| /-+-++-++-+--+++---+--+++---+--+++++---+++--+-+-++--++-++-++-+++++-+++++-++\|||  || ||||||    ||||||||||   |||||||
|||||  ||||| | |  | ||||| ||||| ||| | | || || |  |||   |  |||   |  |||||   \++--+-+-++--++-++-++-+++++-+++++-++++++--++-++++++----++++++++++---+++/|||
|||||  ||||| | |  | ||||| ||||| ||| | | || || |  |||   |  |||   |  |||||    ||  | | ||  || || || ||||| ||||| ||||||  || ||||||    ||||||||||   ||| |||
|||||  ||||| | |  | ||||| ||||| ||| | | || || |  \++---+--+++---+--+++++----++--+-+-++--++-++-++-+++++-+++++-++++++--++-++/||\----++++++++/|   ||| |||
|||||  ||||| | |  | ||||| ||||| ||| | | || || |   ||   |  |||   |/-+++++----++--+-+-++--++-++-++-+++++-+++++-++++++--++-++-++----\|||||||| |   ||| |||
|||||  ||||| \-+--+-+++++-+++++-+++-+-+-++-++-+---++---+--+++---++-+++++----++--+-+-++--++-++-++-+/||| ||||| ||||||/-++-++-++----+++++++++-+-\ ||| |||
|||||  |||||   |  | ||||| ||||| ||| | | || || |  /++---+--+++\  || |||||    ||  | | ||  || || || | ||| ||||| \++++++-++-++-++----+++++++++-+-+-+++-++/
|||||  \++++---+--+-+++++-++++/ ||| | | || || |/-+++---+-\||||  || |||||    ||  | | ||  || || || | ||| ||\++--++++++-++-++-++----+++++++++-/ | ||| ||
|||||   ||||   |  | ||||| ||||  ||| |/+-++-++-++-+++<--+-+++++--++-+++++----++--+-+-++--++\|| || | ||| || ||  |||||| || || ||    |||||||||   | ||| ||
|||||   ||||   |  | ||||| ||||  ||| ||| || || || |||/<-+-+++++--++\|||||    ||  | | ||  ||||| || | ||| ||/++--++++++-++\|| ||    |||||||||   | ||| ||
|||||   ||||   |  | ||||| ||||  ||| ||| || || || ||||  | |||||  ||||||||    ||  | | ||  ||||\-++-+-+++-+++++--++++++-+++++-++----+++++/|||   | ||| ||
|||||   ||||  /+--+-+++++-++++--+++-+++-++-++-++-++++--+-+++++--++++++++----++--+-+-++--++++--++-+-+++\|||||  |||||| ||||| ||    ||||| |||   | ||| ||
|||||   ||||  ||  | ||||| ||||  ||| ||| || |\-++-++++--+-+++++--++++++++----++--+-+-++--++++--++-+-+++++++++--++++++-+++++-++----+/||| |||   | ||| ||
\++++---++++--++--+-+++++-++++--+++-+++-++-+--++-++++--+-+++++--++++++++----++--/ | ||  ||||  || | |||||||||  |||||| ||||| ||    | ||| |||   | ||| ||
 \+++---++++--++--+-+++/| ||||  ||| ||| |\-+--++-++++--+-+++++--++++++++----++----+-++--++++--++-+-+++++++++--++++++-+++++-++----+-+++-/||   | ||| ||
  |||   ||||  ||  | ||| | |||\--+++-+++-+--+--++-++++--+-+++++--++++++++----++----+-+/  ||||  || | |||||||||  |||||| ||||| ||    | |||  ||   | ||| ||
  |||   \+++--++--+-+++-+-+++---+++-++/ |  |  || ||||/-+-+++++--++++++++----++----+-+---++++--++-+-+++++++++--++++++-+++++-++\   | |||  ||   | ||| ||
  |||    |||  ||  | ||| | |||   ||| ||  |  |  \+-+++++-+-+++++--++++++/|    ||    | |   ||||  || | |||||||||  |||||| ||||| |||   | |||  ||   | ||| ||
  |||    |||  ||  | ||| | |||   ||| ||  |  |   | ||||| | |||||  |||||| |    ||    | |   ||||  || | |||||||||  |||||| ||||| |||   | |||  ||   | ||| ||
  |||    ||\--++--+-+++-+-+++---+++-++--+--+---+-+++++-+-+++++--++++++-+----/|    | |   ||||  ||/+-+++++++++--++++++-+++++-+++---+-+++-\||   | ||| ||
  |||    ||   ||/-+-+++-+-+++---+++-++--+--+---+-+++++-+-+++++--++++++-+-----+----+-+---++++-\|||| |||||||||  |||||| ||||| |||   | ||| |||   | ||| ||
  |||    ||   ||| | ||| \-+++---+++-++--+--+---+-+++++-+-+++++--++++++-+-----+----+-+---++++-++/|| |||||||||  |||||| ||||| |||   | ||| |||   | ||| ||
  |||    ||   ||| | |||   |||   ||| ||  \--+---+-+++++-+-+++++--++++++-+-----+----+-+---++++-++-++-+++++++++--/||||| ||||| |||   | ||| |||   | ||| ||
  |||    ||   ||| | |||   |||   ||| ||     |   | ||||| | |||||  |\++++-+--->-+----+-+---++++-++-++-+++++++++---+++++-+++++-+++---/ ||| |||   | ||| ||
  |||    ||   ||| | |||   |||   ||| |\-----+---+-+++++-+-+++++--+-++++-+-----+----+-+---++/| || || |||||||||/--+++++-+++++-+++-----+++-+++---+-+++\||
  |||    ||   ||| | |||   |||   \++-+------+---+-+++++-+-+++++--+-++++-+-----+----+-+---++-+-++-+/ ||||||||||  ||||| ||||| |||     ||| |||   | ||||||
  |||    ||   ||| | |||   \++----++-+------+---+-+/||| | |||||  | |||| \-----+----+-+---++-+-++-+--++++++++++--+++++-+++++-+++-----+++-+/|   | ||||||
  |||    \+---+++-+-+++----++----++-+------+---+-+-+++-+-+++++--+-++++-------+----+-+---++-+-++-+--++++++++++--++/|| ||||| |||     ||| | |   | ||||||
  |||     |   ||| | |||    ||    || |      |   | | ||| | |||||  | ||||       |    | |   || | || \--++++++++++--++-++-+++++-+++-----+++-/ |   | ||||||
  |||     |   ||\-+-+++----++----++-+------+---+-+-+++-+-+++++--+-++++-------+----+-+---++-+-/|    ||||\+++++--++-++-+++++-+++-----+++---/   | ||||||
  |||     |   ||  | |||    ||    |\-+------+---+-+-+++-+-+++++--+-++++-------+----+-+---++-+--+----++++-+++++--++-++-+++++-+/|     |||       | ||||||
  |||   /-+---++--+-+++----++----+--+------+---+-+-+++-+-+++++--+-++++--\    |    | | /-++-+--+----++++-+++++--++-++-+++++-+-+-----+++-------+-++++++\
  |||   | |   ||  | |||    ||    |  |      |   | | \++-+-+++++--+-++++--+----+----+-+-+-++-+--+----++++-+++++--++-++-+++++-+-+-----+++-------+-+/|||||
  |||   | |   ||  | ||\----++----+--+------+---+-+--++-+-+++++--+-++++--+----+----+-+-+-++-+--+----+/|| |||||  || || |||\+-+-+-----+++-------+-+-+++/|
  |||   | |   ||  | ||     ||    |  |      |   | |  || | |||||  | ||||  |    |    | | | |\-+--+----+-++-+++++--++-++-+++-/ | |     |||       | | ||| |
  |||   | |   |\--+-++-----++----+--+------+---+-+--++-+-+++++--+-+/||  |    |    | | | |  |  |    | || |||||  || || |||   | |     |||       | | ||| |
  |||   | |   |   | ||     ||    |  \------+---+-+--++-+-+++++--+-+-++--+----+----+-+-+-+--+--+----+-++-+++++--/| || |||   | |     |||       | | ||| |
  |||   | |   |   | ||     ||    |         |   | |  || | |||||  | | ||  |    |    | | | |  |  |    | || ||\++---+-++-+/|   | |     |||       | | ||| |
  |||   | \---+---+-++-----+/    |    /----+---+-+--++-+-+++++--+-+-++--+----+----+-+-+-+--+--+----+-++-++-++---+-++-+-+---+-+\    |||       | | ||| |
  |||   |     |   | ||     |/----+----+----+---+-+--++\| |||||  | | \+--+----+----+-/ | |  |  |    | || \+-++---+-/| | |   | ||    |||       | | ||| |
  |||   |     |   | ||     |^    |    |    |   | |  |||| |||||  | |  |  |    |    |   | |  |  |    | ||  \-++---+--+-+-/   | ||    |||       | | ||| |
  |||   |     |   | ||     ||    \----+----+---+-+--++++-+++++--+-+--+--+----+----+---+-+--+--+----+-++----++---+--+-+-----+-++----/||       | | ||| |
  |||   |     |   | \+-----++---------+----+---+-+--++++-++/||  | |  |  |    |    |   | |  |  |    | ||    ||   |  \-+-----+-++-----++-------/ | ||| |
  |||   |     |   |  |     ||         |    |   | |  |||| || ||  | |  |  |    |    |   | |  |  |    | ||    ||   |    |     | ||     ||         | ||| |
  |||   |     |   |  |     \+---------+----+---+-+--++++-++-++--+-+--+--+----+----+---+-+--+--+----+-++----++---+----/     | ||     ||         | ||| |
  |||   |     |   |  |      |         |    |   | |  |||\-++-++--+-+--+--+----+----+---+-+--+--+----/ ||    ||   |          | ||     ||         | ||| |
  |||   |     |   |  |      |         |    |   | \--+++--++-+/  | |  |  |    |    |   | |  |  |      ||    ||   |          | ||     ||         | ||| |
  |||   |     |   |  |      |         |    |   \----+++--/\-+---+-+--+--+----+----+---+-+--+--+------++----++---+----------+-++-----++---------+-++/ |
  |||   |     |   |  |      |    /----+----+--------+++-----+-\ | |  |  |    |    |   | |  |  |      \+----++---+----------+-++-----/|         | ||  |
  |||   |     |   |  |      \----+----+----+--------++/     | | | |  |  |    |    |   | |  |  |       |    ||   |          | ||      |         | ||  |
  |||   |     |   \--+-----------+----+----+--------++------+-+-+-+--/  |    \----+---+-+--+--+-------+----++---+----------+-++------+---------/ ||  |
  |||   |     |      |           |    |    |        |\------+-+-+-+-----+---------+---+-+--+--+-------+----++---+----------+-/|      |           ||  |
  |||   |     |      |           |    |    |        \-------+-+-+-/     |         |   | |  |  \-------+----++---+----------+--+------+-----------/|  |
  |\+---+-----+------+-----------+----+----+----------------+-+-+-------+---------/   | |  |          |    ||   |          |  |      |            |  |
  \-+---+-----+------/           |    |    |                | | |       |             | |  |          |    ||   |          |  |      |            |  |
    |   |     |                  |    |    \----------------+-+-+-------+-------------+-+--+----------+----++---+----------+--+------/            |  |
    |   \-----+------------------+----+---------------------+-+-+-------/             \-+--+----------+----++---+----------+--+-------------------+--/
    |         |                  \----+---------------------+-/ |                       |  \----------+----/|   |          |  |                   |
    \---------+-----------------------+---------------------/   |                       \-------------+-----+---+----------/  |                   |
              |                       |                         \-------------------------------------+-----+---/             |                   |
              \-----------------------+---------------------------------------------------------------/     \-----------------+-------------------/
                                      \-------------------------------------------------------------------------------------->/
""".trimIndent()
